Components.utils.import('resource://gre/modules/XPCOMUtils.jsm');  
Components.utils.import('resource://gre/modules/ctypes.jsm');  

function Win7AppId() {
	this.register();
}  
  
Win7AppId.prototype = {  
    // XPCOM
    classDescription: 'Windows 7 Taskbar AppId Setter',
    classID:          Components.ID('{207331f1-1f2f-4ef6-8bc6-5c2a148f4ce3}'),
    contractID:       '@didroe/win7appid;1',
    QueryInterface:   XPCOMUtils.generateQI([Components.interfaces.nsIObserver]),

    // nsIObserver
    // This will get called when the profile has loaded
    observe: function(aSubject, aTopic, aData) {
		var profileName = this.getProfileName();
		var lib = ctypes.open('shell32.dll');  
		// HRESULT SetCurrentProcessExplicitAppUserModelID(__in  PCWSTR AppID);

		var appId = lib.declare('SetCurrentProcessExplicitAppUserModelID',  
								ctypes.winapi_abi, // ABI
								ctypes.int32_t,    // Return type
								ctypes.jschar.ptr);
	
		appId('Mozilla.Firefox.' + profileName);

		lib.close();
 	},
 	register: function () {
		var observerService = Components.classes["@mozilla.org/observer-service;1"]  
							  .getService(Components.interfaces.nsIObserverService);  
		observerService.addObserver(this, "final-ui-startup", false);  
 	},
	getProfileName: function() {
		var profd = Components.classes["@mozilla.org/file/directory_service;1"]
							.getService(Components.interfaces.nsIProperties)
							.get("ProfD", Components.interfaces.nsILocalFile);	
		var profservice = Components.classes["@mozilla.org/toolkit/profile-service;1"]
                              .getService(Components.interfaces.nsIToolkitProfileService);
		var profiles = profservice.profiles;
		var name = null;
		while (profiles.hasMoreElements()) {
			var profile = profiles.getNext().QueryInterface(Components.interfaces.nsIToolkitProfile);
			if (profile.rootDir.path == profd.path) {
				if (profile.name)
					name = profile.name;
				else
					name = profile.rootDir.leafName;
				break;
			}
		}
		return name;
	},
	showAlert: function(head, text) {
		var sbs = Components.classes["@mozilla.org/intl/stringbundle;1"]
                      .getService(Components.interfaces.nsIStringBundleService);
		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                .getService(Components.interfaces.nsIPromptService);
		promptService.alert(null, head || "Alert", text);
	}
}; 

const NSGetFactory = XPCOMUtils.generateNSGetFactory([Win7AppId]);